/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     |
    \\  /    A nd           | Copyright (C) 2011-2013 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

Application
    laplacianAdjointDisplacement

Description
    simple code which morphs the mesh besed on sensitivites

\*---------------------------------------------------------------------------*/

#include "fvCFD.H"
#include "fvMesh.H"
#include "dynamicFvMesh.H"
#include "volPointInterpolation.H"
//#include "simpleControl.H"
//#include "fixedValueFvPatchFields.H"
//#include "zeroGradientFvPatchFields.H"
//#include "wallFvPatch.H"
//#include "patchDist.H"
//#include "wordReListMatcher.H"
//#include "wallDist.H"
//#include "mixedFvPatchFields.H"

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
using namespace Foam;

int main(int argc, char *argv[])
{
    #include "setRootCase.H"

    #include "createTime.H"
    #include "createMesh.H"
    #include "createFields.H"

    // * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * // 


    /*
    Info<< "Time = " << runTime.timeName() << nl << endl;

      


    if(minimize!=internal) Disp *= -1;

    */
    displacement.write();

    solve(-fvm::laplacian(diffusion, displacement));
    pDisplacement = vpi.interpolate(displacement);

    runTime++;

    displacement.write();
    pDisplacement.write();

    vectorField points(mesh.points().size());
    forAll(mesh.points(), pI)
    {
        points[pI] = mesh.points()[pI] + pDisplacement[pI];
    }

    mesh.movePoints(points);
    mesh.write();

      

    Info<< "End\n" << endl;

    return 0;

}


// ************************************************************************* //
